/*
Copyright (C) 2015  Franois GUILLET 

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
#include "Configuration.h"
#include <fstream>
#include <cstdio>
#include <iostream>
using namespace std;

// renvoi vrai si la cl est prsente
bool Configuration::isPresent(string cle)
{
	if (config.count(cle))
	  return true;
	else
	  return false;
}

// renvoi vrai si la configuration a t lue
// (si la map a t remplie avec au moins une valeur)
bool Configuration::estValide()
{
	return valide;
}

// renvoi la valeur associe  la cl sous forme d'entier
int Configuration::getIntVal(string cle)
{
	// si l'option existe, alors on retourne la valeur associe
	if (config.count(cle))
		return atoi(config[cle].c_str());
	else
		return 0;
}

// renvoi la valeur associe  la cl sous forme de flottant
float Configuration::getFloatVal(string cle)
{
	// si l'option existe, alors on retourne la valeur associe
	if (config.count(cle))
		return atof(config[cle].c_str());
	else
		return 0;
}

// renvoi la valeur associe  la cl sous forme de flottant
long Configuration::getLongVal(string cle)
{
	// si l'option existe, alors on retourne la valeur associe
	if (config.count(cle))
		return atol(config[cle].c_str());
	else
		return 0;
}

// renvoi la valeur associe  la cl sous forme de string
string Configuration::getStringVal(string cle)
{
	// si l'option existe, alors on retourne la valeur associe
	if (config.count(cle))
		return config[cle];
	else
		return "";
}


Configuration::Configuration(string ficherConfig)
{
  valide = false;
  
  // parcours du fichier ligne par ligne pour rangement dans la map
  string ligne;

  FILE * pFile;
  int c;
  pFile=fopen (ficherConfig.c_str(),"r");
  
  if (pFile==NULL)
    perror ("Error opening file");
  else
  {
    while ((c = fgetc (pFile)) != EOF)
    {
      
      // si c n'est pas un caractre de fin de ligne, on l'ajoute  ligne
      if (c != 0xA && c != 0xD)
	ligne.push_back(c);
      // sinon, si c'est 0xA, c'est qu'on est en prsence d'une nouvelle ligne
      // il faut donc traiter la ligne actuelle et en faire une nouvelle
      else
      {
	if (c == 0xA)
	{
	  // si la ligne n'est ni un commentaire, ni une ligne vide, 
	  // on range sa cl et sa valeur dans la map
	  if (!isComment(ligne) && !ligne.empty())
	  {
		  string cle = getCle(ligne);
		  
//  		  printf("%s ", cle.c_str());
		  
		  string valeur = getVal(ligne);
//  		  printf("%s\n", valeur.c_str());
		  config[cle] = valeur;
		  valide = true;
	  }
	  ligne = "";
	}
      }
      
    }
    fclose (pFile);
  }

/*

	// ouverture en lecture du fichier de configuration
	ifstream file;
	file.open (ficherConfig.c_str(), ifstream::in);

	
	while (getline (file, ligne))
	{
		// si la ligne n'est ni un commentaire, ni une ligne vide, 
		// on range sa cl et sa valeur dans la map
		if (!isComment(ligne) && !ligne.empty())
		{
			string cle = getCle(ligne);
			string valeur = getVal(ligne);
			config[cle] = valeur;
			valide = true;
		}
	}
	file.close();
	
	*/
	
}

Configuration::~Configuration()
{
    // affichage de la map
//     for ( map<string, string>::const_iterator itMap = config.begin() ; itMap != config.end() ; ++itMap )
//     {
// 	cout  << itMap->first << " vaut " << itMap->second << endl;
//     }
	
}

bool Configuration::isComment(string ligne)
{
	// on enlve les blancs :
	while (ligne[0] == ' ' || ligne[0] == '	')
		ligne.erase(0, 1);
	// on teste le premier caractre
	if (ligne[0] == '#' || ligne[0] == ';')
		return true;
	else
		return false;
}


string Configuration::getCle(string ligne)
{ 
	// indice du premier caractre '='
	int posEgal = ligne.find("=");

	// on prend la sous-chaine
	string cle = ligne.substr (0,posEgal);

	// on enlve les blancs au dbut :
	while (cle[0] == ' ' || cle[0] == '	')
		cle.erase(0, 1);

	// et  la fin :
	while (cle[cle.size() - 1] == ' ' || cle[cle.size() - 1] == '	')
		cle = cle.substr (0,cle.size() - 1);

	return cle;
}

string Configuration::getVal(string ligne)
{
	// indice du premier caractre '='
	int posEgal = ligne.find("=");

	// on prend la sous-chaine
	string val = ligne.substr (posEgal+1);

	// on enlve les blancs au dbut :
	while (val[0] == ' ' || val[0] == '	')
		val.erase(0, 1);

	// et  la fin :
	while (val[val.size() - 1] == ' ' || val[val.size() - 1] == '	')
		val = val.substr (0,val.size() - 1);

	return val;
}
