//Fichiers header et source de la classe Cron
#include "Cron.h"
#include "Base.h"

#include <fstream>
#include <vector>
using namespace std;

//constructeur permettant de charger un fichier de configuration.
Cron::Cron(string fichierConfig){
  // Bouml preserved body begin 00023002
  cout << "programme cronSurveillance" << endl;
  cout << "lecture du fichier de configuration " << fichierConfig << " : "<< endl;
  
  // lecture du fichier de configuration
  Configuration * configuration = new Configuration(fichierConfig);
  string host = configuration->getStringVal("host");
  string db = configuration->getStringVal("db");
  string user = configuration->getStringVal("user");
  string passwd = configuration->getStringVal("passwd");
  short portBd = configuration->getIntVal("portBd");
  string hostHttp = configuration->getStringVal("hostHttp");
  sousDossier = configuration->getStringVal("sousDossier");
  string cheminVideo = configuration->getStringVal("cheminVideo");
  unsigned int idCamera = configuration->getIntVal("idCamera");
//   cheminPageTransfert = configuration->getStringVal("cheminPageTransfert");
  
  delete configuration;
  
  // établir la connextion avec la base :
  cout << "\nBase de données :" << endl;
  cout << "  Base " << db << endl;
  cout << "  Utilisateur " << user << endl;
  cout << "  Serveur " << host << endl;
  base = new Base(host, user, passwd, db, (unsigned int) portBd);
  if (base->get_myok())
    cout << "...connection réussie" << endl;
  else
    cout << "...échec" << endl;
  
  if (base->get_myok())
  {
    // acquisition de l'adresse mail de l'administrateur :
    string adrMail = base->getAdrMail();
//    cout << "adrMail " << adrMail << endl;
    
    // on travaille dans le sous-dossier désigné
    DIR *dir;
    if (dir = opendir (sousDossier.c_str()))
    {
      struct dirent *dp;
      while ((dp = readdir (dir)) != NULL) //tant qu'il y'a des fichiers non lu dans le dossier
      {
	string commande;
	string fichier = dp->d_name;
	
	// si le fichier n'est pas "." ou ".."
	if (fichier != "." and fichier != "..")
	{
	  cout << fichier << endl;
	  // s'il y a assez de place sur le serveur,
	  // on transfère le fichier
	  // et finalement on supprime le fichier
	  
	  // pour savoir s'il y a assez de place sur le serveur il faut :
	  // connaître la place restante sur le serveur. pour cela il faut utiliser ssh et déchiffrer le retour
 	  commande = "ssh www-data@" + hostHttp + " df -k /var/www/  > placerestante.txt";
// 	  cout << commande << endl;
	  system(commande.c_str());
	  string placerestante = "";
	  vector<string> mot;
	  mot.push_back("");
	  std::ifstream is("placerestante.txt");     // open file
	  char c;
	  while (is.get(c))
	  {
	    if (c != ' ' and c != '	')
	      placerestante = placerestante + c;
	    else
	    {
	      mot.push_back(placerestante);
	      placerestante = "";
	    }
	  }
	  is.close();                // close file
	  
//  	  for(int i = 0; i < mot.size(); i++)
//  	    cout <<  i << " : " << mot[i] << endl;
//      placerestante = mot[61];
      placerestante = mot[27];
      int placeRestanteKo = stoi(placerestante);
// 	  cout << placeRestanteKo << endl;
	  
	  // obtension de la taille du fichier en Ko
	  string taille;
	  commande = "find ./" + sousDossier + " -name " + fichier +  " -printf \"%k\" > tailleFichier.txt";
// 	  cout << commande << endl;
	  system(commande.c_str());
	  std::fstream fs;
	  fs.open ("tailleFichier.txt", std::fstream::in | std::fstream::out | std::fstream::app);
	  fs >> taille;
	  fs.close();
	  int tailleKo = stoi(taille);
//  	  cout << tailleKo << endl;

	  // on divise par 1000 pour avoir l'espace en Mo
	  int placeRestanteMo = (placeRestanteKo - tailleKo) / 1000;
	  cout << "placeRestanteMo : " << placeRestanteMo << endl;
	  
	  // obtention de la place restante autorisée par l'application  : interroger la base de donnée
	  int placeRestanteAutorisee = base->getPlaceMin();
	  cout << "placeRestanteAutorisee :  " << placeRestanteAutorisee << endl;
	  
	  // si la taille restante après upload est inférieure à la taille auttorisée,
	  if (placeRestanteAutorisee > placeRestanteMo)
	  {
	    // alors il faut uploader la vidéo
	    commande = "scp -q " + sousDossier + "/" + fichier + " www-data@" + hostHttp + ":html/" + cheminVideo;
	    int retourCommande = system(commande.c_str());
	    // et si ça a réussi, on met à jour la base de données
	    if (retourCommande == 0)
	    {
	      base->ajouterVideo(fichier, idCamera);
	    }
	  }
	  // dans le cas contraire on averti l'administrateur
	  else
	  {
	    commande = "echo \"Plus assez de place disque\" | mail -s \"système Surveillance\" " + adrMail + " -a \"From: " + adrMail + "\"";
	    int retourCommande = system(commande.c_str());
	  }
	  // et au final on supprime le fichier
	  commande = sousDossier + "/" + fichier;
	  remove(commande.c_str());
	  
	  
	}
      }
      closedir(dir);
    }
  }

  
  // Bouml preserved body end 00023002
}

Cron::~Cron(){
  // Bouml preserved body begin 00023082
  delete base;
  // Bouml preserved body end 00023082
}

