
#include "Ordonnanceur.h"
#include "Gpio.h"
#include "Configuration.h"

//Constructeur. Le constructeur cr les objets et initialise les diffrents attributs
//de l'objet  partir du fichier de configuration.
//Ensuite le programme entre dans sa phase de production en appelant la mthode "fonctionner()"
Ordonnanceur::Ordonnanceur(string fichierConfig){
  // Bouml preserved body begin 00021E82


  cout << "Lecture du fichier de configuration \n" << fichierConfig << " : "<< endl;
  
  // lecture du fichier de configuration
  Configuration * configuration = new Configuration(fichierConfig);
  string host = configuration->getStringVal("host");
  string db = configuration->getStringVal("db");
  string user = configuration->getStringVal("user");
  string passwd = configuration->getStringVal("passwd");
  short portBd = configuration->getIntVal("portBd");
  int numGpio = configuration->getIntVal("numGpio");
  string hostHttp = configuration->getStringVal("hostHttp");
//   cheminPageTransfert = configuration->getStringVal("cheminPageTransfert");
  sousDossier = configuration->getStringVal("sousDossier");
  
  idCamera = (unsigned int)configuration->getIntVal("idCamera");
  
  delete configuration;

  // camra
  cout << "Identifiant de la camra : " << idCamera << endl;
  
  // page de transfert
//   cheminPageTransfert = "http://" + hostHttp + "/" + cheminPageTransfert;
//   cout << "\nAdresse de la page de transfert : \n " << cheminPageTransfert << endl; 
  
  // tablir la connextion avec la base :
//   cout << "\nBase de donnes :" << endl;
//   cout << "  Base " << db << endl;
//   cout << "  Utilisateur " << user << endl;
//   cout << "  Serveur " << host << endl;
//   base = new Base(host, user, passwd, db, (unsigned int) portBd);
//   if (base->get_myok())
//     cout << "...connection russie" << endl;
//   else
//     cout << "...chec" << endl;
  
  // capteur de mouvement
  cout << endl << "Pin de connexion du capteur de mouvement sur le gpio :" << numGpio << endl;
  capteur = new Gpio(numGpio);
  capteur->configure(true);
  
//  if (base->get_myok())
  {
    cout << endl << "Le programme commence..." << endl;
    fonctionner();
  }
  
  // Bouml preserved body end 00021E82
}

//destructeur
Ordonnanceur::~Ordonnanceur(){
  // Bouml preserved body begin 00021F02

//   delete base;
  delete capteur;
  // Bouml preserved body end 00021F02
}

//cette mthode est appelle lorsque toutes les initialisations sont ralises et que le programme rentre en phase de production.
void Ordonnanceur::fonctionner() {
  // Bouml preserved body begin 00021F82

  // algo :
  // tant que vrai faire :
  while (true)
  {
    
    // si le capteur de prsence dclenche
    if (capteur->valeurSortie())
    {
      string commande;
      char strNomVideo[200];
      char strIdCamera[100];
      string nomVideo;

      // on fabrique le nom de fichier de la vido,
      // ce nom doit ressembler  "video/camera_2_2020-3-3_6h-8m17s.h264"
      // il est constitu du nom du sous dossier o doit tre rang les vidos
      
//       char * strIdCamera = new char[100];
//       memset(strIdCamera, 0, sizeof(strIdCamera));
//       sprintf(strIdCamera, "%i", idCamera);
//       delete strIdCamera;
      
      memset(&strIdCamera, 0, 100);
      sprintf((char*)strIdCamera, "%i", idCamera);
      
      int heure, min, sec, jour, mois, annee;
      time_t dateActuelle = time(NULL);
      struct tm *maintenant = localtime(&dateActuelle);

      heure = maintenant->tm_hour;
      min = maintenant->tm_min;
      sec = maintenant->tm_sec;
      jour = maintenant->tm_mday;
      mois = maintenant->tm_mon + 1;
      annee = 1900 + maintenant->tm_year;

      memset(&strNomVideo, 0, 200);
      sprintf((char*)strNomVideo, "%s/camera_%i_%i-%02i-%02i_%02ih%02im%02is.h264",sousDossier.c_str(), idCamera, annee, mois, jour, heure, min, sec);
      nomVideo = string(strNomVideo);
      
//       char * strNomVideo = new char[1000];
//       memset(strNomVideo, 0, sizeof(strNomVideo));
//       sprintf(strNomVideo, "%s/camera_%i_%i-%02i-%02i_%02ih%02im%02is.h264",sousDossier.c_str(), idCamera, annee, mois, jour, heure, min, sec);
//       nomVideo = string(strNomVideo);
//       delete strNomVideo;

      
      
      cout << "nomVideo : " << nomVideo << endl;
      
      // puis on lance une acquisition vido pendant 5 secondes (avec une commande genre "raspivid -o video.h264")
      commande = "raspivid -o " + nomVideo;
      system(commande.c_str());
      
      // pour laisser un peu de temps au processeur
      usleep(100);
      
    }
  }
  // Bouml preserved body end 00021F82
}

